/***************************************************************************
 *   Copyright (C) 2009 by Minh Anh Thi Nguyen, Steffen Klaere, Arndt von Haeseler   *
 *   {minh.anh.nguyen, steffen.klaere, arndt.von.haeseler}@univie.ac.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "intinterval.h"

IntInterval::IntInterval()
{
	marked = false;
}

IntInterval::IntInterval(const int abegin, const bool amarked)
{
	begin = abegin;
	end = abegin;
	amount = 1;
	marked = amarked;
}

IntInterval::IntInterval (const int abegin, const int aend, const bool amarked)
{
	assert(abegin <= aend);
	begin = abegin;
	end = aend;
	amount = aend - abegin + 1;
	marked = amarked;
}

IntInterval::~IntInterval()
{
}

void IntInterval::setBegin(const int aInt)
{
	begin = aInt;
}
	
void IntInterval::setEnd(const int aInt)
{
	end = aInt;
}

void IntInterval::mark(const bool mark)
{
	marked = mark;
}

void IntInterval::updateAmount()
{
	assert(begin < end);
	amount = end - begin + 1;
}
