/***************************************************************************
 *   Copyright (C) 2009 by Minh Anh Thi Nguyen, Steffen Klaere, Arndt von Haeseler   *
 *   {minh.anh.nguyen, steffen.klaere, arndt.von.haeseler}@univie.ac.at   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "splitset.h"

void SplitSet::removeAll() {
	for (reverse_iterator it = rbegin(); it != rend(); it++)
		if (*it) 
		{
			delete *it;
// 			(*it) = NULL;
		}
	clear();
}

SplitSet::~SplitSet()
{
	removeAll();
// 	cout << "SplitSet deleted" << endl;		
}

/*void SplitSet::genPatterns(const PatternSet &sourceSet, const PatternSet &referSet, const PatternSet &referSet2, PatternSet &returnSet, PatternSet &returnSet2, const int aMutStep)
{	
	for (PatternSet::const_iterator sourceIt = sourceSet.begin(); sourceIt != sourceSet.end(); sourceIt++)
	{
		for (iterator it = begin(); it != end(); it++)
		{
			for (int mutType = 1; mutType < MutType; mutType++)
			{
				Pattern *curPat = (*sourceIt)->mutated((*it),mutType);
				PatternSet::iterator findIt = referSet.find(curPat);
				if (findIt == referSet.end())
				{
					curPat->setMutStep(aMutStep);
					PatternSet::iterator findIt2 = referSet2.find(curPat);
					if (findIt2 != referSet2.end())
														
						returnSet2.addPattern(curPat);				
					else
						returnSet.addPattern(curPat);
				}			
			}
		}
	}	
}*/

void SplitSet::genPatterns(const PatternSet &sourceSet, const PatternSet &referSet, const PatternSet &referSet2, PatternSet &returnSet, PatternSet &returnSet2)
{	
	for (PatternSet::const_iterator sourceIt = sourceSet.begin(); sourceIt != sourceSet.end(); sourceIt++)
	{
		for (iterator it = begin(); it != end(); it++)
		{
			for (int mutType = 1; mutType < MutType; mutType++)
			{
				Pattern *curPat = (*sourceIt)->mutated((*it),mutType);
				PatternSet::iterator findIt = referSet.find(curPat);
				if (findIt == referSet.end())
				{
					curPat->setMutStep((*sourceIt)->getMutStep()+1);
					PatternSet::iterator findIt2 = referSet2.find(curPat);
					if (findIt2 != referSet2.end())					
						returnSet2.addPattern(curPat);
					else					
						returnSet.addPattern(curPat); 						
				}			
			}
		}
	}	
}

/*void SplitSet::genPatterns(const PatternSet &sourcePat, PatternSet &returnSet, const int mutType, const PatternSet &referenceSet, const int max)
{
	bool stop = false;
	int numGenPat = 0; //number of generated patterns which are not in referenceSet
// 	PatternSet retSet;
	int sourceNum = sourcePat.size();
	
	for (int i = 0; i < sourceNum && stop == false; i++)
	{
		for (iterator it = begin(); it != end() && stop == false; it++)
		{
			Pattern *curPat = sourcePat[i]->mutated((*it),mutType);
			if (referenceSet.searchPattern((*curPat)) == -1)
			{
// 				retSet.addPattern(curPat);
				returnSet.addPattern(curPat);
				numGenPat++;
			}
			if (numGenPat == max)
				stop = true;
		}
	}	
// 	returnSet = retSet;
}

void SplitSet::genPatterns(const PatternSet &sourcePat, PatternSet &returnSet, const int mutType, const PatternSet &referSet, const int max, const PatternSet &referSet2, PatternSet &returnSet2)
{
	bool stop = false;
	int numGenPat = 0; //number of generated patterns which are not in referenceSet
// 	PatternSet retSet;
	int sourceNum = sourcePat.size();
	
	for (int i = 0; i < sourceNum && stop == false; i++)
	{
		for (iterator it = begin(); it != end() && stop == false; it++)
		{
			Pattern *curPat = sourcePat[i]->mutated((*it),mutType);
			if (referSet.searchPattern((*curPat)) == -1)
			{
// 				retSet.addPattern(curPat);
				if (referSet2.searchPattern((*curPat)) != -1)
				{
					returnSet2.addPattern(curPat);
				}
				else
				{
					returnSet.addPattern(curPat);
					numGenPat++;
				}
			}
			if (numGenPat == max)
				stop = true;
		}
	}	
// 	returnSet = retSet;
}*/

/*!
    \fn SplitSet::print(ostream& out)
 */
void SplitSet::print(ostream &out)
{
	if ((*this).empty())
	{
// 		outError("Try to print an emply Split set!");
		out <<  "The split is empty!" << endl;
	}
	else
	{
		int row = size();
		int col = (*this)[0]->size();
		out << row << " " << col << endl;
		for (iterator it = begin(); it < end(); it++)
		{
			(*it)->printSplit(out);
			out << endl;		
		}
	}
}





